/************************************************************************
* Copyright (c) 1995 Valentin Shopov, Blagoevgrad, Bulgaria		*
*									*
* Permission to use, copy, modify, and distribute this material for any	*
* purpose and without fee is hereby granted, provided that the above	*
* copyright notice and this permission notice appear in all copies, and	*
* that the name of the author not be used in advertising or publicity 	*
* pertaining to this material without the specific, prior written 	*
* permission of the author.						*
*									*
* THE AUTHOR MAKES NO REPRESENTATIONS ABOUT THE ACCURACY OR SUITABILITY	*  
* OF THIS MATERIAL FOR ANY PURPOSE. IT IS PROVIDED "AS IS", WITHOUT ANY	* 
* EXPRESS OR IMPLIED WARRANTIES.					*
*************************************************************************/

/**************************ciilib1.0.4***********************************
 *									*
 *        Character to Inline Image Conversion Library (CIILIB)		*
 *									*
 *	Encoder for Character by Inline Image of HTML on HTTP		*
 *			by Valentin Shopov				*
 *			valentin@rs.aubg.bg				*
 ************************************************************************/

#include <stdio.h>
/*
int CII_isPRE;
*/
static int isTag, isTitle, isAnchor, is2inA;

#if defined PLUS256C
extern char *chsetabbr[];
extern int numof256c;
extern char *xbmsrc_256[][257];
extern int xbmind_256[][257];
#else if
static char *chsetabbr[]={0};
static int numof256c=0;
static char *xbmsrc_256[1][257];
static int xbmind_256[1][257];
#endif

extern char *CharsetID(/* char *abbr */);

static int to256c(csname)
	char *csname;
{	char *charset;

	if( (charset = CharsetID(csname)) == 0 )
		return 0;
        return strncasecmp(charset,"ISO-8859-",9) == 0;
}
static int is256c(charsets)
	char *charsets[];
{	int convnum,i;
	char *charset;

        if(numof256c && to256c(charsets[0]) ){
        convnum=0;
        for(i=0;chsetabbr[i];i++){
		if( charset = CharsetID(chsetabbr[i]) )
                if( charset == CharsetID(charsets[0]) ){
                        convnum=i;
                        break;
                }
        }
	}
        else convnum=-1;
        return(convnum);
}

unsigned char *
EUC_TO_CII(src,dst,ctype,charsets,ubase)
unsigned char *src, *dst;
char *ctype,*charsets[],*ubase;
{	register unsigned char *sp,*dp;
	char *charset;
	int isPlain,do256,cs256;

	isPlain = strcasecmp(ctype,"text/plain") == 0;
	charset = CharsetID(charsets[0]);
	if( charset == NULL ){
		strcpy(dst,src);
		return dst;
	}
	do256 = to256c(charsets[0]);

	for(sp=src, dp=dst; *sp; ){
/*
	if(CII_isPRE>0 && isPlain){
	sprintf(dp,"<PRE>");
	dp+=5;
	CII_isPRE=-1;
	}
*/
	if(*sp == '<' && !isTag && !isPlain){
		isTag=1;
		if(!isAnchor && (!strncasecmp(sp,"<A ",3) || !strncasecmp(sp,"<A>",3))) isAnchor=1;
		else
		if(!isAnchor && !strncasecmp(sp,"</A>",4)){ sp+=4; isTag=0;}
		else
		if(!isTitle && !strncasecmp(sp,"<TITLE>",7)) isTitle = 1;
		else
		if(isTitle && !strncasecmp(sp,"</TITLE>",8)) isTitle = 0;
	}
	if(isTag || isTitle){
		if(*sp == '>' && isTag) isTag = 0;
		*dp++ = *sp++;
	}
	else{



		if( *sp & 0x80 ){
			if(isAnchor && !is2inA) is2inA=1;
			else
			if(isAnchor && is2inA){
				sprintf(dp,"</A>");
				dp+=4;
				is2inA=0;
				isAnchor=0;
			}
			if( do256 ){
			 if( (cs256=is256c(charsets))!=-1){
			  sprintf(dp,"<IMG SRC=\"%s%s/%02x%02x\">",ubase,charset,cs256,sp[0]);
		       	  dp += strlen(dp);
			 }
			 sp++;
			}
			else {
			if(sp[1] & 0x80){
				sprintf(dp,"<IMG SRC=\"%s%s/%x%x\">",ubase,charset,sp[0],sp[1]);
				dp += strlen(dp); sp += 2;
			}else	sp++;
			}
		}else{	if(isPlain){ switch(*sp) {
				case '<' : 
					sprintf(dp,"&lt;");
					dp += 4; sp++;
					break;
				case '>' : 
					sprintf(dp,"&gt;");
					dp += 4; sp++;
					break;
				case '&' : 
					sprintf(dp,"&amp;");
					dp += 5; sp++;
					break;
				case '"' : 
					sprintf(dp,"&quot;");
					dp += 6; sp++;
					break;
				default:
					*dp++ = *sp++;
					break;
				    }
			}else *dp++ = *sp++;
		}
	}
	}
	*dp = 0;
	return dst;
}
CII_toCII(any,gr,ctype,charsets,ubase)
	unsigned char *any,*gr;
	char *ctype,*charsets[];
	char *ubase;
{	char *euc,*iifl;
	int i;
        if( to256c(charsets[0]) ) EUC_TO_CII(any,gr,ctype,charsets,ubase);
	else{
	euc = (char*)malloc(strlen(any)+1);
	TO_EUC(any,euc);
	EUC_TO_CII(euc,gr,ctype,charsets,ubase);
	free(euc);
	}
}

extern char *xbmsrc[];
extern int xbmind[];
static char *getCII_JIS(name,xbmbuf)
	char *name,*xbmbuf;
{	int i,euc,kanind;
	char *gkand,*curxbm;
	gkand = xbmbuf;
	sscanf(name,"%x",&euc);
	kanind=(euc/256-161)*94 + euc%256-161;
	if(xbmind[kanind] == -1) return 0;
	curxbm = xbmsrc[xbmind[kanind]];
	sprintf(gkand,"#define %s_width 16\n#define %s_height 16\nstatic char %s_bits[] = {\n\0",name,name,name);
	for(i = 0; i< 32; i++) {
	sprintf(gkand+strlen(gkand),"0x%02x,\0",(unsigned char)curxbm[i]);
	}
	sprintf(gkand+strlen(gkand)-1,"};\n\0");
	return gkand;
}

static char *getCII_256(name,xbmbuf)
        char *name,*xbmbuf;
{       int i,code,cindr,cindc;
        char *gchd,*curxbm;
        gchd = xbmbuf;
        sscanf(name,"%x",&code);
        cindr=code/256; cindc=code%256; 
	if(cindr>numof256c || xbmind_256[cindr][cindc] == -1) return 0;
        curxbm = xbmsrc_256[cindr][xbmind_256[cindr][cindc]];
        sprintf(gchd,"#define %s_width 8\n#define %s_height 16\nstatic char %s_bits[] = {\n\0",name,name,name);
        for(i = 0; i< 16; i++) {
        sprintf(gchd+strlen(gchd),"0x%02x,\0",(unsigned char)curxbm[i]);
        }
        sprintf(gchd+strlen(gchd)-1,"};\n\0");
        return gchd;
}
char *CII_getXBM(name,xbmbuf)
	char *name;
{	char charset[32],code[32];
	char *getCII_JIS(),*getCII_256();

	sscanf(name,"%[^/]/%s",charset,code);
	if( to256c(charset) )
		return getCII_256(code,xbmbuf);
	else	return getCII_JIS(code,xbmbuf);
}

CII_putHTTP(tc,vno,gkan)
	FILE *tc;
	char *gkan;
{	char *data;
	int size;
	int leng = 0;
	char xbmbuf[500];

	if( (data = CII_getXBM(gkan,xbmbuf)) == 0 )
		return 0;

	size = strlen(data);
	leng += HTTP_putHeader(tc,vno,"image/x-xbitmap",size);
	leng += fwrite(data,1,size,tc);
	return leng;
}

